"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`).  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from redrover_api.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from redrover_api.exceptions import ApiAttributeError


def lazy_import():
    from redrover_api.model.int32_locator_request import Int32LocatorRequest
    from redrover_api.model.substitute_attribute_request import SubstituteAttributeRequest
    from redrover_api.model.substitute_related_org_request import SubstituteRelatedOrgRequest
    globals()['Int32LocatorRequest'] = Int32LocatorRequest
    globals()['SubstituteAttributeRequest'] = SubstituteAttributeRequest
    globals()['SubstituteRelatedOrgRequest'] = SubstituteRelatedOrgRequest


class SubstituteRequest(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('state',): {
            'None': None,
            'INVALID': "Invalid",
            'AL': "AL",
            'AK': "AK",
            'AZ': "AZ",
            'AR': "AR",
            'CA': "CA",
            'CO': "CO",
            'CT': "CT",
            'DE': "DE",
            'FL': "FL",
            'GA': "GA",
            'HI': "HI",
            'ID': "ID",
            'IL': "IL",
            'IN': "IN",
            'IA': "IA",
            'KS': "KS",
            'KY': "KY",
            'LA': "LA",
            'ME': "ME",
            'MD': "MD",
            'MA': "MA",
            'MI': "MI",
            'MN': "MN",
            'MS': "MS",
            'MO': "MO",
            'MT': "MT",
            'NE': "NE",
            'NV': "NV",
            'NH': "NH",
            'NJ': "NJ",
            'NM': "NM",
            'NY': "NY",
            'NC': "NC",
            'ND': "ND",
            'OH': "OH",
            'OK': "OK",
            'OR': "OR",
            'PA': "PA",
            'RI': "RI",
            'SC': "SC",
            'SD': "SD",
            'TN': "TN",
            'TX': "TX",
            'UT': "UT",
            'VT': "VT",
            'VA': "VA",
            'WA': "WA",
            'WV': "WV",
            'WI': "WI",
            'WY': "WY",
            'AS': "AS",
            'DC': "DC",
            'FM': "FM",
            'GU': "GU",
            'MH': "MH",
            'MP': "MP",
            'PW': "PW",
            'PR': "PR",
            'VI': "VI",
            'AB': "AB",
            'BC': "BC",
            'MB': "MB",
            'NB': "NB",
            'NL': "NL",
            'NS': "NS",
            'NT': "NT",
            'NU': "NU",
            'ON': "ON",
            'PE': "PE",
            'QC': "QC",
            'SK': "SK",
            'YT': "YT",
        },
        ('country',): {
            'None': None,
            'INVALID': "Invalid",
            'US': "US",
            'CA': "CA",
            'MX': "MX",
            'AC': "AC",
            'AD': "AD",
            'AE': "AE",
            'AF': "AF",
            'AG': "AG",
            'AI': "AI",
            'AL': "AL",
            'AM': "AM",
            'AN': "AN",
            'AO': "AO",
            'AR': "AR",
            'AT': "AT",
            'AU': "AU",
            'AW': "AW",
            'AX': "AX",
            'AZ': "AZ",
            'BA': "BA",
            'BB': "BB",
            'BD': "BD",
            'BE': "BE",
            'BF': "BF",
            'BG': "BG",
            'BH': "BH",
            'BI': "BI",
            'BJ': "BJ",
            'BM': "BM",
            'BN': "BN",
            'BO': "BO",
            'BR': "BR",
            'BS': "BS",
            'BT': "BT",
            'BW': "BW",
            'BY': "BY",
            'BZ': "BZ",
            'CC': "CC",
            'CD': "CD",
            'CF': "CF",
            'CG': "CG",
            'CH': "CH",
            'CI': "CI",
            'CK': "CK",
            'CL': "CL",
            'CM': "CM",
            'CN': "CN",
            'CO': "CO",
            'CR': "CR",
            'CU': "CU",
            'CV': "CV",
            'CX': "CX",
            'CY': "CY",
            'CZ': "CZ",
            'DE': "DE",
            'DJ': "DJ",
            'DK': "DK",
            'DM': "DM",
            'DO': "DO",
            'DZ': "DZ",
            'EC': "EC",
            'EE': "EE",
            'EG': "EG",
            'ES': "ES",
            'ET': "ET",
            'FI': "FI",
            'FJ': "FJ",
            'FK': "FK",
            'FM': "FM",
            'FO': "FO",
            'FR': "FR",
            'GA': "GA",
            'GD': "GD",
            'GE': "GE",
            'GF': "GF",
            'GH': "GH",
            'GI': "GI",
            'GL': "GL",
            'GM': "GM",
            'GN': "GN",
            'GP': "GP",
            'GQ': "GQ",
            'GR': "GR",
            'GS': "GS",
            'GT': "GT",
            'GU': "GU",
            'GW': "GW",
            'GY': "GY",
            'HK': "HK",
            'HN': "HN",
            'HR': "HR",
            'HT': "HT",
            'HU': "HU",
            'ID': "ID",
            'IE': "IE",
            'IL': "IL",
            'IM': "IM",
            'IN': "IN",
            'IO': "IO",
            'IQ': "IQ",
            'IR': "IR",
            'IS': "IS",
            'IT': "IT",
            'JM': "JM",
            'JO': "JO",
            'JP': "JP",
            'KE': "KE",
            'KG': "KG",
            'KH': "KH",
            'KI': "KI",
            'KM': "KM",
            'KN': "KN",
            'KP': "KP",
            'KR': "KR",
            'KW': "KW",
            'KY': "KY",
            'KZ': "KZ",
            'LA': "LA",
            'LB': "LB",
            'LC': "LC",
            'LI': "LI",
            'LK': "LK",
            'LR': "LR",
            'LS': "LS",
            'LT': "LT",
            'LU': "LU",
            'LV': "LV",
            'LY': "LY",
            'MA': "MA",
            'MC': "MC",
            'MD': "MD",
            'ME': "ME",
            'MG': "MG",
            'MH': "MH",
            'MK': "MK",
            'ML': "ML",
            'MM': "MM",
            'MN': "MN",
            'MO': "MO",
            'MP': "MP",
            'MQ': "MQ",
            'MR': "MR",
            'MS': "MS",
            'MT': "MT",
            'MU': "MU",
            'MV': "MV",
            'MW': "MW",
            'MY': "MY",
            'MZ': "MZ",
            'NA': "NA",
            'NC': "NC",
            'NE': "NE",
            'NF': "NF",
            'NG': "NG",
            'NI': "NI",
            'NL': "NL",
            'NO': "NO",
            'NP': "NP",
            'NR': "NR",
            'NU': "NU",
            'NZ': "NZ",
            'OM': "OM",
            'PA': "PA",
            'PE': "PE",
            'PF': "PF",
            'PG': "PG",
            'PH': "PH",
            'PK': "PK",
            'PL': "PL",
            'PM': "PM",
            'PN': "PN",
            'PR': "PR",
            'PS': "PS",
            'PT': "PT",
            'PW': "PW",
            'PY': "PY",
            'QA': "QA",
            'RE': "RE",
            'RO': "RO",
            'RS': "RS",
            'RU': "RU",
            'RW': "RW",
            'SA': "SA",
            'SB': "SB",
            'SC': "SC",
            'SD': "SD",
            'SE': "SE",
            'SG': "SG",
            'SH': "SH",
            'SI': "SI",
            'SJ': "SJ",
            'SK': "SK",
            'SL': "SL",
            'SM': "SM",
            'SN': "SN",
            'SO': "SO",
            'SR': "SR",
            'SS': "SS",
            'ST': "ST",
            'SV': "SV",
            'SY': "SY",
            'SZ': "SZ",
            'TC': "TC",
            'TD': "TD",
            'TF': "TF",
            'TG': "TG",
            'TH': "TH",
            'TJ': "TJ",
            'TK': "TK",
            'TM': "TM",
            'TN': "TN",
            'TO': "TO",
            'TP': "TP",
            'TR': "TR",
            'TT': "TT",
            'TV': "TV",
            'TW': "TW",
            'TZ': "TZ",
            'UA': "UA",
            'UG': "UG",
            'UK': "UK",
            'UY': "UY",
            'UZ': "UZ",
            'VA': "VA",
            'VC': "VC",
            'VE': "VE",
            'VG': "VG",
            'VI': "VI",
            'VN': "VN",
            'VU': "VU",
            'WF': "WF",
            'WS': "WS",
            'YE': "YE",
            'YT': "YT",
            'ZA': "ZA",
            'ZM': "ZM",
            'ZW': "ZW",
        },
    }

    validations = {
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'id': (int, none_type,),  # noqa: E501
            'secondary_identifier': (str, none_type,),  # noqa: E501
            'external_id': (str, none_type,),  # noqa: E501
            'first_name': (str, none_type,),  # noqa: E501
            'middle_name': (str, none_type,),  # noqa: E501
            'last_name': (str, none_type,),  # noqa: E501
            'email': (str, none_type,),  # noqa: E501
            'date_of_birth': (datetime, none_type,),  # noqa: E501
            'address1': (str, none_type,),  # noqa: E501
            'address2': (str, none_type,),  # noqa: E501
            'city': (str, none_type,),  # noqa: E501
            'postal_code': (str, none_type,),  # noqa: E501
            'badge_number': (str, none_type,),  # noqa: E501
            'state': (str, none_type,),  # noqa: E501
            'country': (str, none_type,),  # noqa: E501
            'phone_number': (str, none_type,),  # noqa: E501
            'active': (bool,),  # noqa: E501
            'permission_set': (Int32LocatorRequest,),  # noqa: E501
            'remove_future_assignments_on_inactivate': (bool, none_type,),  # noqa: E501
            'invite_immediately': (bool, none_type,),  # noqa: E501
            'replace_existing_related_orgs': (bool,),  # noqa: E501
            'related_orgs': ([SubstituteRelatedOrgRequest], none_type,),  # noqa: E501
            'replace_existing_attributes': (bool,),  # noqa: E501
            'attributes': ([SubstituteAttributeRequest], none_type,),  # noqa: E501
            'pay_code': (Int32LocatorRequest,),  # noqa: E501
            'related_org_ids': ([int], none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'id': 'id',  # noqa: E501
        'secondary_identifier': 'secondaryIdentifier',  # noqa: E501
        'external_id': 'externalId',  # noqa: E501
        'first_name': 'firstName',  # noqa: E501
        'middle_name': 'middleName',  # noqa: E501
        'last_name': 'lastName',  # noqa: E501
        'email': 'email',  # noqa: E501
        'date_of_birth': 'dateOfBirth',  # noqa: E501
        'address1': 'address1',  # noqa: E501
        'address2': 'address2',  # noqa: E501
        'city': 'city',  # noqa: E501
        'postal_code': 'postalCode',  # noqa: E501
        'badge_number': 'badgeNumber',  # noqa: E501
        'state': 'state',  # noqa: E501
        'country': 'country',  # noqa: E501
        'phone_number': 'phoneNumber',  # noqa: E501
        'active': 'active',  # noqa: E501
        'permission_set': 'permissionSet',  # noqa: E501
        'remove_future_assignments_on_inactivate': 'removeFutureAssignmentsOnInactivate',  # noqa: E501
        'invite_immediately': 'inviteImmediately',  # noqa: E501
        'replace_existing_related_orgs': 'replaceExistingRelatedOrgs',  # noqa: E501
        'related_orgs': 'relatedOrgs',  # noqa: E501
        'replace_existing_attributes': 'replaceExistingAttributes',  # noqa: E501
        'attributes': 'attributes',  # noqa: E501
        'pay_code': 'payCode',  # noqa: E501
        'related_org_ids': 'relatedOrgIds',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """SubstituteRequest - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            id (int, none_type): The Red Rover internal Id of OrgUser (numeric). [optional]  # noqa: E501
            secondary_identifier (str, none_type): The secondary identifier for the User. [optional]  # noqa: E501
            external_id (str, none_type): The external Id of OrgUser (alpha-numeric). [optional]  # noqa: E501
            first_name (str, none_type): The User's first name. [optional]  # noqa: E501
            middle_name (str, none_type): The User's middle name. [optional]  # noqa: E501
            last_name (str, none_type): The User's last name. [optional]  # noqa: E501
            email (str, none_type): The User's email. [optional]  # noqa: E501
            date_of_birth (datetime, none_type): The User's date of birth. [optional]  # noqa: E501
            address1 (str, none_type): The User's address. [optional]  # noqa: E501
            address2 (str, none_type): The User's address (continued). [optional]  # noqa: E501
            city (str, none_type): The User's city. [optional]  # noqa: E501
            postal_code (str, none_type): The User's postal code. [optional]  # noqa: E501
            badge_number (str, none_type): The User's badge number. [optional]  # noqa: E501
            state (str, none_type): The User's state. [optional]  # noqa: E501
            country (str, none_type): The User's country. [optional]  # noqa: E501
            phone_number (str, none_type): The User's phone number. [optional]  # noqa: E501
            active (bool): If the user is active. (Default is true). [optional]  # noqa: E501
            permission_set (Int32LocatorRequest): [optional]  # noqa: E501
            remove_future_assignments_on_inactivate (bool, none_type): If all assignments are to be removed if the user is inactivated at any time. [optional]  # noqa: E501
            invite_immediately (bool, none_type): If the user is to receive an invitation email right away. [optional]  # noqa: E501
            replace_existing_related_orgs (bool): If related Organizations are to be replaced. (Default is true). [optional]  # noqa: E501
            related_orgs ([SubstituteRelatedOrgRequest], none_type): Related Organizations. [optional]  # noqa: E501
            replace_existing_attributes (bool): If related Attributes are to be replaced. (Default is true). [optional]  # noqa: E501
            attributes ([SubstituteAttributeRequest], none_type): Related Attributes. [optional]  # noqa: E501
            pay_code (Int32LocatorRequest): [optional]  # noqa: E501
            related_org_ids ([int], none_type): Related Organization Ids. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """SubstituteRequest - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            id (int, none_type): The Red Rover internal Id of OrgUser (numeric). [optional]  # noqa: E501
            secondary_identifier (str, none_type): The secondary identifier for the User. [optional]  # noqa: E501
            external_id (str, none_type): The external Id of OrgUser (alpha-numeric). [optional]  # noqa: E501
            first_name (str, none_type): The User's first name. [optional]  # noqa: E501
            middle_name (str, none_type): The User's middle name. [optional]  # noqa: E501
            last_name (str, none_type): The User's last name. [optional]  # noqa: E501
            email (str, none_type): The User's email. [optional]  # noqa: E501
            date_of_birth (datetime, none_type): The User's date of birth. [optional]  # noqa: E501
            address1 (str, none_type): The User's address. [optional]  # noqa: E501
            address2 (str, none_type): The User's address (continued). [optional]  # noqa: E501
            city (str, none_type): The User's city. [optional]  # noqa: E501
            postal_code (str, none_type): The User's postal code. [optional]  # noqa: E501
            badge_number (str, none_type): The User's badge number. [optional]  # noqa: E501
            state (str, none_type): The User's state. [optional]  # noqa: E501
            country (str, none_type): The User's country. [optional]  # noqa: E501
            phone_number (str, none_type): The User's phone number. [optional]  # noqa: E501
            active (bool): If the user is active. (Default is true). [optional]  # noqa: E501
            permission_set (Int32LocatorRequest): [optional]  # noqa: E501
            remove_future_assignments_on_inactivate (bool, none_type): If all assignments are to be removed if the user is inactivated at any time. [optional]  # noqa: E501
            invite_immediately (bool, none_type): If the user is to receive an invitation email right away. [optional]  # noqa: E501
            replace_existing_related_orgs (bool): If related Organizations are to be replaced. (Default is true). [optional]  # noqa: E501
            related_orgs ([SubstituteRelatedOrgRequest], none_type): Related Organizations. [optional]  # noqa: E501
            replace_existing_attributes (bool): If related Attributes are to be replaced. (Default is true). [optional]  # noqa: E501
            attributes ([SubstituteAttributeRequest], none_type): Related Attributes. [optional]  # noqa: E501
            pay_code (Int32LocatorRequest): [optional]  # noqa: E501
            related_org_ids ([int], none_type): Related Organization Ids. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
