# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.  # Authentication The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.  This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.  Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.  # API Information ## Api Key Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.  You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.  ## Identifier Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`).  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from redrover_api.configuration import Configuration


class AbsenceDetailCreateRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'date': 'datetime',
        'day_part': 'str',
        'description': 'str',
        'start_time': 'datetime',
        'end_time': 'datetime',
        'reasons': 'list[AbsenceReasonUsageCreateRequest]'
    }

    attribute_map = {
        'date': 'date',
        'day_part': 'dayPart',
        'description': 'description',
        'start_time': 'startTime',
        'end_time': 'endTime',
        'reasons': 'reasons'
    }

    def __init__(self, date=None, day_part=None, description=None, start_time=None, end_time=None, reasons=None, local_vars_configuration=None):  # noqa: E501
        """AbsenceDetailCreateRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._date = None
        self._day_part = None
        self._description = None
        self._start_time = None
        self._end_time = None
        self._reasons = None
        self.discriminator = None

        self.date = date
        self.day_part = day_part
        self.description = description
        self.start_time = start_time
        self.end_time = end_time
        self.reasons = reasons

    @property
    def date(self):
        """Gets the date of this AbsenceDetailCreateRequest.  # noqa: E501

        The Date of the AbsenceDetail  # noqa: E501

        :return: The date of this AbsenceDetailCreateRequest.  # noqa: E501
        :rtype: datetime
        """
        return self._date

    @date.setter
    def date(self, date):
        """Sets the date of this AbsenceDetailCreateRequest.

        The Date of the AbsenceDetail  # noqa: E501

        :param date: The date of this AbsenceDetailCreateRequest.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and date is None:  # noqa: E501
            raise ValueError("Invalid value for `date`, must not be `None`")  # noqa: E501

        self._date = date

    @property
    def day_part(self):
        """Gets the day_part of this AbsenceDetailCreateRequest.  # noqa: E501

        The part of the day that the AbsenceDetail spans  # noqa: E501

        :return: The day_part of this AbsenceDetailCreateRequest.  # noqa: E501
        :rtype: str
        """
        return self._day_part

    @day_part.setter
    def day_part(self, day_part):
        """Sets the day_part of this AbsenceDetailCreateRequest.

        The part of the day that the AbsenceDetail spans  # noqa: E501

        :param day_part: The day_part of this AbsenceDetailCreateRequest.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and day_part is None:  # noqa: E501
            raise ValueError("Invalid value for `day_part`, must not be `None`")  # noqa: E501
        allowed_values = ["Invalid", "FullDay", "HalfDayMorning", "HalfDayAfternoon", "QuarterDayEarlyMorning", "QuarterDayLateMorning", "QuarterDayEarlyAfternoon", "QuarterDayLateAfternoon", "Hourly", "PeriodByPeriod"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and day_part not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `day_part` ({0}), must be one of {1}"  # noqa: E501
                .format(day_part, allowed_values)
            )

        self._day_part = day_part

    @property
    def description(self):
        """Gets the description of this AbsenceDetailCreateRequest.  # noqa: E501


        :return: The description of this AbsenceDetailCreateRequest.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this AbsenceDetailCreateRequest.


        :param description: The description of this AbsenceDetailCreateRequest.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def start_time(self):
        """Gets the start_time of this AbsenceDetailCreateRequest.  # noqa: E501

        The start time of the AbsenceDetail  # noqa: E501

        :return: The start_time of this AbsenceDetailCreateRequest.  # noqa: E501
        :rtype: datetime
        """
        return self._start_time

    @start_time.setter
    def start_time(self, start_time):
        """Sets the start_time of this AbsenceDetailCreateRequest.

        The start time of the AbsenceDetail  # noqa: E501

        :param start_time: The start_time of this AbsenceDetailCreateRequest.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and start_time is None:  # noqa: E501
            raise ValueError("Invalid value for `start_time`, must not be `None`")  # noqa: E501

        self._start_time = start_time

    @property
    def end_time(self):
        """Gets the end_time of this AbsenceDetailCreateRequest.  # noqa: E501

        The start time of the AbsenceDetail  # noqa: E501

        :return: The end_time of this AbsenceDetailCreateRequest.  # noqa: E501
        :rtype: datetime
        """
        return self._end_time

    @end_time.setter
    def end_time(self, end_time):
        """Sets the end_time of this AbsenceDetailCreateRequest.

        The start time of the AbsenceDetail  # noqa: E501

        :param end_time: The end_time of this AbsenceDetailCreateRequest.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and end_time is None:  # noqa: E501
            raise ValueError("Invalid value for `end_time`, must not be `None`")  # noqa: E501

        self._end_time = end_time

    @property
    def reasons(self):
        """Gets the reasons of this AbsenceDetailCreateRequest.  # noqa: E501

        The Reasons for absence in this AbsenceDetail  # noqa: E501

        :return: The reasons of this AbsenceDetailCreateRequest.  # noqa: E501
        :rtype: list[AbsenceReasonUsageCreateRequest]
        """
        return self._reasons

    @reasons.setter
    def reasons(self, reasons):
        """Sets the reasons of this AbsenceDetailCreateRequest.

        The Reasons for absence in this AbsenceDetail  # noqa: E501

        :param reasons: The reasons of this AbsenceDetailCreateRequest.  # noqa: E501
        :type: list[AbsenceReasonUsageCreateRequest]
        """
        if self.local_vars_configuration.client_side_validation and reasons is None:  # noqa: E501
            raise ValueError("Invalid value for `reasons`, must not be `None`")  # noqa: E501

        self._reasons = reasons

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AbsenceDetailCreateRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AbsenceDetailCreateRequest):
            return True

        return self.to_dict() != other.to_dict()
