# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.  # Authentication The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.  This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.  Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.  # API Information ## Api Key Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.  You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.  ## Identifier Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`).  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from redrover_api.configuration import Configuration


class AccountingCodeAllocationRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'accounting_code_id': 'int',
        'allocation': 'float'
    }

    attribute_map = {
        'accounting_code_id': 'accountingCodeId',
        'allocation': 'allocation'
    }

    def __init__(self, accounting_code_id=None, allocation=None, local_vars_configuration=None):  # noqa: E501
        """AccountingCodeAllocationRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._accounting_code_id = None
        self._allocation = None
        self.discriminator = None

        self.accounting_code_id = accounting_code_id
        self.allocation = allocation

    @property
    def accounting_code_id(self):
        """Gets the accounting_code_id of this AccountingCodeAllocationRequest.  # noqa: E501

        The Red Rover internal Id of AccountingCode (numeric)  # noqa: E501

        :return: The accounting_code_id of this AccountingCodeAllocationRequest.  # noqa: E501
        :rtype: int
        """
        return self._accounting_code_id

    @accounting_code_id.setter
    def accounting_code_id(self, accounting_code_id):
        """Sets the accounting_code_id of this AccountingCodeAllocationRequest.

        The Red Rover internal Id of AccountingCode (numeric)  # noqa: E501

        :param accounting_code_id: The accounting_code_id of this AccountingCodeAllocationRequest.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and accounting_code_id is None:  # noqa: E501
            raise ValueError("Invalid value for `accounting_code_id`, must not be `None`")  # noqa: E501

        self._accounting_code_id = accounting_code_id

    @property
    def allocation(self):
        """Gets the allocation of this AccountingCodeAllocationRequest.  # noqa: E501

        How much of the Accounting Code is allocated  # noqa: E501

        :return: The allocation of this AccountingCodeAllocationRequest.  # noqa: E501
        :rtype: float
        """
        return self._allocation

    @allocation.setter
    def allocation(self, allocation):
        """Sets the allocation of this AccountingCodeAllocationRequest.

        How much of the Accounting Code is allocated  # noqa: E501

        :param allocation: The allocation of this AccountingCodeAllocationRequest.  # noqa: E501
        :type: float
        """
        if self.local_vars_configuration.client_side_validation and allocation is None:  # noqa: E501
            raise ValueError("Invalid value for `allocation`, must not be `None`")  # noqa: E501

        self._allocation = allocation

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AccountingCodeAllocationRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AccountingCodeAllocationRequest):
            return True

        return self.to_dict() != other.to_dict()
