# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.  # Authentication The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.  This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.  Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.  # API Information ## Api Key Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.  You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.  ## Identifier Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`).  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from redrover_api.configuration import Configuration


class CustomAttributeData(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'attribute_type': 'Type',
        'constructor': 'ConstructorInfo',
        'constructor_arguments': 'list[CustomAttributeTypedArgument]',
        'named_arguments': 'list[CustomAttributeNamedArgument]'
    }

    attribute_map = {
        'attribute_type': 'attributeType',
        'constructor': 'constructor',
        'constructor_arguments': 'constructorArguments',
        'named_arguments': 'namedArguments'
    }

    def __init__(self, attribute_type=None, constructor=None, constructor_arguments=None, named_arguments=None, local_vars_configuration=None):  # noqa: E501
        """CustomAttributeData - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._attribute_type = None
        self._constructor = None
        self._constructor_arguments = None
        self._named_arguments = None
        self.discriminator = None

        if attribute_type is not None:
            self.attribute_type = attribute_type
        if constructor is not None:
            self.constructor = constructor
        self.constructor_arguments = constructor_arguments
        self.named_arguments = named_arguments

    @property
    def attribute_type(self):
        """Gets the attribute_type of this CustomAttributeData.  # noqa: E501


        :return: The attribute_type of this CustomAttributeData.  # noqa: E501
        :rtype: Type
        """
        return self._attribute_type

    @attribute_type.setter
    def attribute_type(self, attribute_type):
        """Sets the attribute_type of this CustomAttributeData.


        :param attribute_type: The attribute_type of this CustomAttributeData.  # noqa: E501
        :type: Type
        """

        self._attribute_type = attribute_type

    @property
    def constructor(self):
        """Gets the constructor of this CustomAttributeData.  # noqa: E501


        :return: The constructor of this CustomAttributeData.  # noqa: E501
        :rtype: ConstructorInfo
        """
        return self._constructor

    @constructor.setter
    def constructor(self, constructor):
        """Sets the constructor of this CustomAttributeData.


        :param constructor: The constructor of this CustomAttributeData.  # noqa: E501
        :type: ConstructorInfo
        """

        self._constructor = constructor

    @property
    def constructor_arguments(self):
        """Gets the constructor_arguments of this CustomAttributeData.  # noqa: E501


        :return: The constructor_arguments of this CustomAttributeData.  # noqa: E501
        :rtype: list[CustomAttributeTypedArgument]
        """
        return self._constructor_arguments

    @constructor_arguments.setter
    def constructor_arguments(self, constructor_arguments):
        """Sets the constructor_arguments of this CustomAttributeData.


        :param constructor_arguments: The constructor_arguments of this CustomAttributeData.  # noqa: E501
        :type: list[CustomAttributeTypedArgument]
        """

        self._constructor_arguments = constructor_arguments

    @property
    def named_arguments(self):
        """Gets the named_arguments of this CustomAttributeData.  # noqa: E501


        :return: The named_arguments of this CustomAttributeData.  # noqa: E501
        :rtype: list[CustomAttributeNamedArgument]
        """
        return self._named_arguments

    @named_arguments.setter
    def named_arguments(self, named_arguments):
        """Sets the named_arguments of this CustomAttributeData.


        :param named_arguments: The named_arguments of this CustomAttributeData.  # noqa: E501
        :type: list[CustomAttributeNamedArgument]
        """

        self._named_arguments = named_arguments

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CustomAttributeData):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CustomAttributeData):
            return True

        return self.to_dict() != other.to_dict()
