# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.  # Authentication The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.  This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.  Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.  # API Information ## Api Key Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.  You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.  ## Identifier Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`).  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from redrover_api.configuration import Configuration


class PropertyInfo(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'declaring_type': 'Type',
        'reflected_type': 'Type',
        'module': 'Module',
        'custom_attributes': 'list[CustomAttributeData]',
        'is_collectible': 'bool',
        'metadata_token': 'int',
        'member_type': 'str',
        'property_type': 'Type',
        'attributes': 'str',
        'is_special_name': 'bool',
        'can_read': 'bool',
        'can_write': 'bool',
        'get_method': 'MethodInfo',
        'set_method': 'MethodInfo'
    }

    attribute_map = {
        'name': 'name',
        'declaring_type': 'declaringType',
        'reflected_type': 'reflectedType',
        'module': 'module',
        'custom_attributes': 'customAttributes',
        'is_collectible': 'isCollectible',
        'metadata_token': 'metadataToken',
        'member_type': 'memberType',
        'property_type': 'propertyType',
        'attributes': 'attributes',
        'is_special_name': 'isSpecialName',
        'can_read': 'canRead',
        'can_write': 'canWrite',
        'get_method': 'getMethod',
        'set_method': 'setMethod'
    }

    def __init__(self, name=None, declaring_type=None, reflected_type=None, module=None, custom_attributes=None, is_collectible=None, metadata_token=None, member_type=None, property_type=None, attributes=None, is_special_name=None, can_read=None, can_write=None, get_method=None, set_method=None, local_vars_configuration=None):  # noqa: E501
        """PropertyInfo - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._declaring_type = None
        self._reflected_type = None
        self._module = None
        self._custom_attributes = None
        self._is_collectible = None
        self._metadata_token = None
        self._member_type = None
        self._property_type = None
        self._attributes = None
        self._is_special_name = None
        self._can_read = None
        self._can_write = None
        self._get_method = None
        self._set_method = None
        self.discriminator = None

        self.name = name
        if declaring_type is not None:
            self.declaring_type = declaring_type
        if reflected_type is not None:
            self.reflected_type = reflected_type
        if module is not None:
            self.module = module
        self.custom_attributes = custom_attributes
        if is_collectible is not None:
            self.is_collectible = is_collectible
        if metadata_token is not None:
            self.metadata_token = metadata_token
        if member_type is not None:
            self.member_type = member_type
        if property_type is not None:
            self.property_type = property_type
        if attributes is not None:
            self.attributes = attributes
        if is_special_name is not None:
            self.is_special_name = is_special_name
        if can_read is not None:
            self.can_read = can_read
        if can_write is not None:
            self.can_write = can_write
        if get_method is not None:
            self.get_method = get_method
        if set_method is not None:
            self.set_method = set_method

    @property
    def name(self):
        """Gets the name of this PropertyInfo.  # noqa: E501


        :return: The name of this PropertyInfo.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PropertyInfo.


        :param name: The name of this PropertyInfo.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def declaring_type(self):
        """Gets the declaring_type of this PropertyInfo.  # noqa: E501


        :return: The declaring_type of this PropertyInfo.  # noqa: E501
        :rtype: Type
        """
        return self._declaring_type

    @declaring_type.setter
    def declaring_type(self, declaring_type):
        """Sets the declaring_type of this PropertyInfo.


        :param declaring_type: The declaring_type of this PropertyInfo.  # noqa: E501
        :type: Type
        """

        self._declaring_type = declaring_type

    @property
    def reflected_type(self):
        """Gets the reflected_type of this PropertyInfo.  # noqa: E501


        :return: The reflected_type of this PropertyInfo.  # noqa: E501
        :rtype: Type
        """
        return self._reflected_type

    @reflected_type.setter
    def reflected_type(self, reflected_type):
        """Sets the reflected_type of this PropertyInfo.


        :param reflected_type: The reflected_type of this PropertyInfo.  # noqa: E501
        :type: Type
        """

        self._reflected_type = reflected_type

    @property
    def module(self):
        """Gets the module of this PropertyInfo.  # noqa: E501


        :return: The module of this PropertyInfo.  # noqa: E501
        :rtype: Module
        """
        return self._module

    @module.setter
    def module(self, module):
        """Sets the module of this PropertyInfo.


        :param module: The module of this PropertyInfo.  # noqa: E501
        :type: Module
        """

        self._module = module

    @property
    def custom_attributes(self):
        """Gets the custom_attributes of this PropertyInfo.  # noqa: E501


        :return: The custom_attributes of this PropertyInfo.  # noqa: E501
        :rtype: list[CustomAttributeData]
        """
        return self._custom_attributes

    @custom_attributes.setter
    def custom_attributes(self, custom_attributes):
        """Sets the custom_attributes of this PropertyInfo.


        :param custom_attributes: The custom_attributes of this PropertyInfo.  # noqa: E501
        :type: list[CustomAttributeData]
        """

        self._custom_attributes = custom_attributes

    @property
    def is_collectible(self):
        """Gets the is_collectible of this PropertyInfo.  # noqa: E501


        :return: The is_collectible of this PropertyInfo.  # noqa: E501
        :rtype: bool
        """
        return self._is_collectible

    @is_collectible.setter
    def is_collectible(self, is_collectible):
        """Sets the is_collectible of this PropertyInfo.


        :param is_collectible: The is_collectible of this PropertyInfo.  # noqa: E501
        :type: bool
        """

        self._is_collectible = is_collectible

    @property
    def metadata_token(self):
        """Gets the metadata_token of this PropertyInfo.  # noqa: E501


        :return: The metadata_token of this PropertyInfo.  # noqa: E501
        :rtype: int
        """
        return self._metadata_token

    @metadata_token.setter
    def metadata_token(self, metadata_token):
        """Sets the metadata_token of this PropertyInfo.


        :param metadata_token: The metadata_token of this PropertyInfo.  # noqa: E501
        :type: int
        """

        self._metadata_token = metadata_token

    @property
    def member_type(self):
        """Gets the member_type of this PropertyInfo.  # noqa: E501


        :return: The member_type of this PropertyInfo.  # noqa: E501
        :rtype: str
        """
        return self._member_type

    @member_type.setter
    def member_type(self, member_type):
        """Sets the member_type of this PropertyInfo.


        :param member_type: The member_type of this PropertyInfo.  # noqa: E501
        :type: str
        """
        allowed_values = ["Constructor", "Event", "Field", "Method", "Property", "TypeInfo", "Custom", "NestedType", "All"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and member_type not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `member_type` ({0}), must be one of {1}"  # noqa: E501
                .format(member_type, allowed_values)
            )

        self._member_type = member_type

    @property
    def property_type(self):
        """Gets the property_type of this PropertyInfo.  # noqa: E501


        :return: The property_type of this PropertyInfo.  # noqa: E501
        :rtype: Type
        """
        return self._property_type

    @property_type.setter
    def property_type(self, property_type):
        """Sets the property_type of this PropertyInfo.


        :param property_type: The property_type of this PropertyInfo.  # noqa: E501
        :type: Type
        """

        self._property_type = property_type

    @property
    def attributes(self):
        """Gets the attributes of this PropertyInfo.  # noqa: E501


        :return: The attributes of this PropertyInfo.  # noqa: E501
        :rtype: str
        """
        return self._attributes

    @attributes.setter
    def attributes(self, attributes):
        """Sets the attributes of this PropertyInfo.


        :param attributes: The attributes of this PropertyInfo.  # noqa: E501
        :type: str
        """
        allowed_values = ["None", "SpecialName", "RTSpecialName", "HasDefault", "Reserved2", "Reserved3", "Reserved4", "ReservedMask"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and attributes not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `attributes` ({0}), must be one of {1}"  # noqa: E501
                .format(attributes, allowed_values)
            )

        self._attributes = attributes

    @property
    def is_special_name(self):
        """Gets the is_special_name of this PropertyInfo.  # noqa: E501


        :return: The is_special_name of this PropertyInfo.  # noqa: E501
        :rtype: bool
        """
        return self._is_special_name

    @is_special_name.setter
    def is_special_name(self, is_special_name):
        """Sets the is_special_name of this PropertyInfo.


        :param is_special_name: The is_special_name of this PropertyInfo.  # noqa: E501
        :type: bool
        """

        self._is_special_name = is_special_name

    @property
    def can_read(self):
        """Gets the can_read of this PropertyInfo.  # noqa: E501


        :return: The can_read of this PropertyInfo.  # noqa: E501
        :rtype: bool
        """
        return self._can_read

    @can_read.setter
    def can_read(self, can_read):
        """Sets the can_read of this PropertyInfo.


        :param can_read: The can_read of this PropertyInfo.  # noqa: E501
        :type: bool
        """

        self._can_read = can_read

    @property
    def can_write(self):
        """Gets the can_write of this PropertyInfo.  # noqa: E501


        :return: The can_write of this PropertyInfo.  # noqa: E501
        :rtype: bool
        """
        return self._can_write

    @can_write.setter
    def can_write(self, can_write):
        """Sets the can_write of this PropertyInfo.


        :param can_write: The can_write of this PropertyInfo.  # noqa: E501
        :type: bool
        """

        self._can_write = can_write

    @property
    def get_method(self):
        """Gets the get_method of this PropertyInfo.  # noqa: E501


        :return: The get_method of this PropertyInfo.  # noqa: E501
        :rtype: MethodInfo
        """
        return self._get_method

    @get_method.setter
    def get_method(self, get_method):
        """Sets the get_method of this PropertyInfo.


        :param get_method: The get_method of this PropertyInfo.  # noqa: E501
        :type: MethodInfo
        """

        self._get_method = get_method

    @property
    def set_method(self):
        """Gets the set_method of this PropertyInfo.  # noqa: E501


        :return: The set_method of this PropertyInfo.  # noqa: E501
        :rtype: MethodInfo
        """
        return self._set_method

    @set_method.setter
    def set_method(self, set_method):
        """Sets the set_method of this PropertyInfo.


        :param set_method: The set_method of this PropertyInfo.  # noqa: E501
        :type: MethodInfo
        """

        self._set_method = set_method

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PropertyInfo):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PropertyInfo):
            return True

        return self.to_dict() != other.to_dict()
