# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.  # Authentication The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.  This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.  Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.  # API Information ## Api Key Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.  You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.  ## Identifier Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`).  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from redrover_api.configuration import Configuration


class SubstitutePreferencesRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'favorite_substitutes': 'list[Int32LocatorRequest]',
        'blocked_substitutes': 'list[Int32LocatorRequest]',
        'auto_assigned_substitutes': 'list[Int32LocatorRequest]'
    }

    attribute_map = {
        'favorite_substitutes': 'favoriteSubstitutes',
        'blocked_substitutes': 'blockedSubstitutes',
        'auto_assigned_substitutes': 'autoAssignedSubstitutes'
    }

    def __init__(self, favorite_substitutes=None, blocked_substitutes=None, auto_assigned_substitutes=None, local_vars_configuration=None):  # noqa: E501
        """SubstitutePreferencesRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._favorite_substitutes = None
        self._blocked_substitutes = None
        self._auto_assigned_substitutes = None
        self.discriminator = None

        self.favorite_substitutes = favorite_substitutes
        self.blocked_substitutes = blocked_substitutes
        self.auto_assigned_substitutes = auto_assigned_substitutes

    @property
    def favorite_substitutes(self):
        """Gets the favorite_substitutes of this SubstitutePreferencesRequest.  # noqa: E501

        Substitutes that are preferred favorites  # noqa: E501

        :return: The favorite_substitutes of this SubstitutePreferencesRequest.  # noqa: E501
        :rtype: list[Int32LocatorRequest]
        """
        return self._favorite_substitutes

    @favorite_substitutes.setter
    def favorite_substitutes(self, favorite_substitutes):
        """Sets the favorite_substitutes of this SubstitutePreferencesRequest.

        Substitutes that are preferred favorites  # noqa: E501

        :param favorite_substitutes: The favorite_substitutes of this SubstitutePreferencesRequest.  # noqa: E501
        :type: list[Int32LocatorRequest]
        """

        self._favorite_substitutes = favorite_substitutes

    @property
    def blocked_substitutes(self):
        """Gets the blocked_substitutes of this SubstitutePreferencesRequest.  # noqa: E501

        Substitutes that are blocked  # noqa: E501

        :return: The blocked_substitutes of this SubstitutePreferencesRequest.  # noqa: E501
        :rtype: list[Int32LocatorRequest]
        """
        return self._blocked_substitutes

    @blocked_substitutes.setter
    def blocked_substitutes(self, blocked_substitutes):
        """Sets the blocked_substitutes of this SubstitutePreferencesRequest.

        Substitutes that are blocked  # noqa: E501

        :param blocked_substitutes: The blocked_substitutes of this SubstitutePreferencesRequest.  # noqa: E501
        :type: list[Int32LocatorRequest]
        """

        self._blocked_substitutes = blocked_substitutes

    @property
    def auto_assigned_substitutes(self):
        """Gets the auto_assigned_substitutes of this SubstitutePreferencesRequest.  # noqa: E501

        Substitutes that can be auto assigned  # noqa: E501

        :return: The auto_assigned_substitutes of this SubstitutePreferencesRequest.  # noqa: E501
        :rtype: list[Int32LocatorRequest]
        """
        return self._auto_assigned_substitutes

    @auto_assigned_substitutes.setter
    def auto_assigned_substitutes(self, auto_assigned_substitutes):
        """Sets the auto_assigned_substitutes of this SubstitutePreferencesRequest.

        Substitutes that can be auto assigned  # noqa: E501

        :param auto_assigned_substitutes: The auto_assigned_substitutes of this SubstitutePreferencesRequest.  # noqa: E501
        :type: list[Int32LocatorRequest]
        """

        self._auto_assigned_substitutes = auto_assigned_substitutes

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SubstitutePreferencesRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SubstitutePreferencesRequest):
            return True

        return self.to_dict() != other.to_dict()
